
local M = {}

local init = 0
local filesDeleted = false
local finished = 0
local i = 1
local i2 = 1
local iApp = 0
local pattern
local configsList
local first = 0
local particles = require("particles")
local materials = particles.getMaterialsParticlesTable()


local function test()

end

--=======================================================DELETE USELESS FILES=========================================================
local function deleteFiles()
	if(FS:fileExists("mods/sirenmod/cache/")) and finished ~= 1 then -- If cache folder exist
	pattern = FS:findFilesByRootPattern('game:mods/sirenmod/cache/', '*.json', -1, true, false) -- Get all files in cache
		while finished ~= 1 do -- While all files haven't be deleted		
			if pattern[i] == nil then -- If pattern return null it's that all files have been deleted
				finished = 1 -- So it's finished
			else
				FS:removeFile(pattern[i]) -- Remove file
			end
			i = i + 1 -- Next file
		end
		finished = 0 -- Reset the values when it's finished
		i = 1
	end	
	
	
	configsList = FS:findFilesByRootPattern('game:mods/sirenmod/vehiclesConfig/', '*.json', -1, true, false)
	serializeJsonToFile("mods/sirenmod/cache/configsList.json", configsList, true)
	
end
--=======================================================DELETE USELESS FILES=========================================================







--======================================================================CAMERA AND DELETE USELESS FILES========================================================================
local function onUpdate(dt)
	if camera ~= nil and be:getPlayerVehicle(0) ~= -1 and camera.getActiveMode(0) ~= nil then -- If camera is not null
			be:getPlayerVehicle(0):queueLuaCommand('drivingSounds.cameraMode = (\"'..camera.getActiveMode(0)..'\")')
	end	
	if be:getPlayerVehicleID(0) == -1 and FS:fileExists("") == true and filesDeleted == false then deleteFiles() filesDeleted = true end -- If "FS function" have been loaded	
end
--======================================================================CAMERA AND DELETE USELESS FILES========================================================================







--======================================================================WOOSH SOUND========================================================================
local function onVehicleSwitched(oldId, newId, player)	
		if oldId ~= newId then
				be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.onVehicleSwitched() end') -- Call onVehicleSwitched function
				be:getObjectByID(newId):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switch = (\"'..newId..'\") end') -- Tell to the new vehicle that it's focused then play first person sounds again
				if oldId ~= -1 then be:getObjectByID(oldId):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switch = (\"'..newId..'\") end ') end -- Tell to the old vehicle that is no longer focused then stop first person sounds
		end	
end
--======================================================================WOOSH SOUND========================================================================





local function onClientEndMission()
	deleteFiles()
end


local function onVehicleSpawned(veh)
	be:getPlayerVehicle(0):queueLuaCommand("extensions.addModulePath('lua/vehicle/extensions/SAH')") -- Load lua files
 	be:getPlayerVehicle(0):queueLuaCommand("extensions.loadModulesInDirectory('lua/vehicle/extensions/SAH', true)")
end

local function onCameraModeChanged(cameraMode)
	if tostring(cameraMode) == "onboard.driver" then cameraMode = "dash" end -- Get camera mode
	be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.cameraMode = (\"'..cameraMode..'\") end ') -- Send it to vehicle lua
end






M.test = test
M.onCameraModeChanged= onCameraModeChanged
M.iApp = iApp
M.deleteFiles 		 = deleteFiles
M.onVehicleSwitched  = onVehicleSwitched
M.onVehicleSpawned = onVehicleSpawned
M.onUpdate = onUpdate

return M