

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

--============VALUES==============
local errorConfig = 1
local configInit = false
local vehicleConfig = ""
local jsonFile = ""
local i
local configCalled = 0
local init = 0
local latestConfig
local errorCounter = 0
--============VALUES==============







--==============================================JSON CONFIG================================================
local function jsonInitFunc()

	local vehicleName = v.vehicles.vehicleDirectory:gsub("vehicles/", ""):gsub("/", "") --Get vehicle name
	local settings = readJsonFile("/mods/sirenmod/config/settings.json") --Get settings
	local vehicleID = jsonInit.vehicleID
	obj:queueGameEngineLua("core_camera.switchCamera(0, 1) 	core_camera.switchCamera(0, -1)")
	
	print("Vehicle name: "..vehicleName)
	print("Vehicle configuration: "..vehicleConfig)
	print(" ")


	if vehicleConfig == "unknown" then -- If user have changed something on the vehicle
		
		if vehicleID == nil then vehicleID = "unknown" end
		
		if FS:fileExists("mods/sirenmod/cache/"..vehicleID..".json") then -- If vehicleID have memory file	
			latestConfig = readJsonFile("/mods/sirenmod/cache/"..vehicleID..".json") --Get latest config
		else -- Not supposed to happen but if the player touch the temporary folder it can happen
			print("Error: No temporary file found for "..vehicleID.." ID. Did you touched the temporary folder ? Using default.json...")
			latestConfig = readJsonFile("mods/sirenmod/vehiclesConfig/default.json")
		end
	
		if latestConfig.LatestConfig ~= nil then print("Vehicle seem to be modified, using the latest configuration used. ("..latestConfig.LatestConfig..")") end
		vehicleConfig = latestConfig.LatestConfig	
	end

	if jsonFile == "" then 

		if(FS:fileExists("mods/sirenmod/vehiclesConfig/".. vehicleConfig ..".json")) then --If "carname.json" file exist then
			jsonFile = readJsonFile("mods/sirenmod/vehiclesConfig/".. vehicleConfig ..".json") --Read "carname.json" file
			print("JSON configuration found for ".. vehicleConfig .. ".")
			i = {["LatestConfig"] = vehicleConfig}
			serializeJsonToFile("mods/sirenmod/cache/"..vehicleID..".json", i, true) -- Create a memory file that contain the vehicle config to prevent bugs
	
	
		elseif(FS:fileExists("mods/sirenmod/vehiclesConfig/".. vehicleName ..".json")) then --If "carname.json" file exist then
			jsonFile = readJsonFile("mods/sirenmod/vehiclesConfig/".. vehicleName ..".json") --Read "carname.json" file
			print("No JSON configuration found for \"".. vehicleConfig .. ".json\", using "..vehicleName.." configuration.")
			print("JSON configuration found for ".. vehicleName .. ".")
			i = {["LatestConfig"] = vehicleName}
			serializeJsonToFile("mods/sirenmod/cache/"..vehicleID..".json", i, true) -- Create a memory file that contain the vehicle config to prevent bugs
		else
			jsonFile = readJsonFile("mods/sirenmod/vehiclesConfig/default.json")
			print("No JSON configuration found for \"".. vehicleConfig .. ".json\", using "..vehicleName.." configuration.")
			print("No JSON configuration found for \"".. vehicleName .. ".json\", using default configuration.")
			i = {["LatestConfig"] = "default"}
			serializeJsonToFile("mods/sirenmod/cache/"..vehicleID..".json", i, true) -- Create a memory file that contain the vehicle config to prevent bugs
		end	
		
		if jsonFile == nil then jsonFile = readJsonFile("mods/sirenmod/vehiclesConfig/default.json") print("ERROR: Loading default configuration...") end
		
		hornSirenSounds.jsonInit(jsonFile)
		vehicleSounds.jsonInit(jsonFile, settings)
		drivingSounds.jsonInit(jsonFile,  settings)
		
	end
	





			

	
	
end
--==============================================JSON CONFIG================================================







--==========================================================================GET VEHICLE CONFIG============================================================================
local function getVehicleConfig()

end



local function onUpdate(dt) --ONUPDATE OPEN
--[[
	if configInit == false then	 --If vehicleConfig have not been initialized then
		if vehicleConfig == nil then --If vehicleConfig =/= null
			if errorConfig < 3 then		 --If the code haven't give 3 time the same error
				if pcall(getVehicleConfig) then --Call getVehicleConfig in protected mode to prevent error
				else 
				errorConfig = errorConfig + 1  --If getVehicleConfig return error 
				end
			else vehicleConfig = "Unknown" print(vehicleConfig) jsonInitFunc() configInit = true --If the code have return 3 error it's that the user have modified the vehicle then give up
			end			
		else print(vehicleConfig) jsonInitFunc() configInit = true end		 --If the code doesn't return error then the user haven't modifed his vehicle
	end
--]]
	
	if init == 0 and jsonInit.vehicleConfig == nil and errorCounter < 3 then
		obj:queueGameEngineLua("be:getPlayerVehicle(0):queueLuaCommand('jsonInit.vehicleConfig = (\"'..be:getPlayerVehicle(0):getField('partConfig', '')..'\")')")
		obj:queueGameEngineLua("be:getPlayerVehicle(0):queueLuaCommand('jsonInit.vehicleID = (\"'..be:getPlayerVehicleID(0)..'\")')")
		errorCounter = errorCounter + 1
		if errorCounter > 2 then jsonInit.vehicleConfig = "unknown" print("No configuration found, vehicle have been modified") end
	elseif init == 0 and jsonInit.vehicleConfig ~= nil then 
		init = 1
		vehicleConfig = jsonInit.vehicleConfig
		vehicleConfig = vehicleConfig:gsub("vehicles/", ""):gsub("/", "_"):lower():gsub(".pc", "") --Delete all / and useless text
		jsonInitFunc()
	end

end --ONUPDATE CLOSE
--==========================================================================GET VEHICLE CONFIG============================================================================	







--========================================================INITILIZATION==========================================================
local function onInit()
	obj:queueGameEngineLua("be:getPlayerVehicle(0):queueLuaCommand('jsonInit.vehicleID = (\"'..be:getPlayerVehicleID(0)..'\")')")
	if configInit == false and configCalled < 1 then
		pcall(getVehicleConfig)
		configCalled = configCalled + 1
	end	
end
--========================================================INITILIZATION==========================================================
local function appApply(vehicle)

	jsonFile = readJsonFile("mods/sirenmod/vehiclesConfig/"..vehicle)

	hornSirenSounds.jsonInit(jsonFile)
	vehicleSounds.jsonInit(jsonFile, settings)
	drivingSounds.jsonInit(jsonFile,  settings)

end


M.appApply    = appApply
M.initFunc    = initFunc
M.onUpdate    = onUpdate
M.onReset     = onInit
M.updateGFX   = onUpdate

return M


--[[
I write the vehicle configuration in the latestConfig.json because if player modify his vehicle (by changing the engine or anything else)
the mod doesn't detect the vehicle config anymore, so it take the latest known configuration.
--]]