

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

local vehicleConfig = ""
local settingsUser = ""
local path = "mods/sirenmod/sounds/"
local blinker1 local blinker2
local isRadiatorDamaged = 0
local crashDelay = 0
local velocity = 0
local velocityMem = 0
--==============================================JSON CONFIG================================================
local function jsonInit(jsonFile, settings)
	vehicleConfig = jsonFile
	settingsUser = settings
	blinker1 = sounds.createSFXSource(path..vehicleConfig.blinkerOn,  'AudioDefault3D', "blinker1"..vehicleConfig.Name, v.data.refNodes[0].ref)
	blinker2 = sounds.createSFXSource(path..vehicleConfig.blinkerOff, 'AudioDefault3D', "blinker2"..vehicleConfig.Name, v.data.refNodes[0].ref)
end
--==============================================JSON CONFIG================================================




local engineBeepSound = false
local vehicleName
vehicleName = v.vehicles.vehicleDirectory:gsub("vehicles/", ""):gsub("/", "")
local smokeSound = sounds.createSFXSource('art/sound/smoke.ogg', 'AudioDefaultLoop3D', "SmokeSound", v.data.refNodes[0].ref)
--========================================================INITILIZATION==========================================================
local function onInit()
	obj:setVolumePitch(smokeSound, 0, 1)
	engineBeepSound = false
	isRadiatorDamaged = 0
	crashDelay = 0
	--drivingSounds.isTireDeflated = false
end
--========================================================INITILIZATION==========================================================







--================================================================VALUES==================================================================
local metal1 = 			sounds.createSFXSource('art/sound/metal1.ogg', 			'AudioDefault3D', 		"Metal1Sound", 		 v.data.refNodes[0].ref)
local metal2 = 			sounds.createSFXSource('art/sound/metal2.ogg', 			'AudioDefault3D', 		"Metal2Sound",		 v.data.refNodes[0].ref)
local handbrakeLock = 	sounds.createSFXSource('art/sound/handbrakelock.ogg', 	'AudioDefault3D', 		"handbrakeLock",	 v.data.refNodes[0].ref)
local handbrakeUnlock = sounds.createSFXSource('art/sound/handbrakeunlock.ogg', 'AudioDefault3D', 		"handbrakeUnlock"  , v.data.refNodes[0].ref)
local lightsSound = 	sounds.createSFXSource('art/sound/lights.ogg', 			'AudioDefault3D', 		"lights", 			 v.data.refNodes[0].ref)
local shifter1 =    	sounds.createSFXSource('art/sound/shift1.ogg',       	'AudioDefault3D', 		"shift1", 			 v.data.refNodes[0].ref)
local shifter2 =    	sounds.createSFXSource('art/sound/shift2.ogg',       	'AudioDefault3D', 		"shift2", 			 v.data.refNodes[0].ref)
local shifter3 =    	sounds.createSFXSource('art/sound/shift3.ogg',       	'AudioDefault3D', 		"shift3", 			 v.data.refNodes[0].ref)
local reverseSound =	sounds.createSFXSource('art/sound/truckreverse.ogg', 	'AudioDefaultLoop3D', 	"reverse",			 v.data.refNodes[0].ref)
local engineStart  = 	sounds.createSFXSource('art/sound/enginestart.ogg',  	'AudioDefault3D', 		"start", 			 v.data.refNodes[0].ref)
local beep = 			sounds.createSFXSource('art/sound/beep.ogg', 			'AudioDefaultLoop3D',   "beep",				 v.data.refNodes[0].ref)
local rfan = 			sounds.createSFXSource('art/sound/radiatorfan.ogg', 	'AudioDefaultLoop3D',   "rfan",				 v.data.refNodes[0].ref)
local scrape = 			sounds.createSFXSource('art/sound/scrape.ogg', 			'AudioDefaultLoop3D',   "scrape",			 v.data.refNodes[0].ref)
local tire = 			sounds.createSFXSource('art/sound/tireDeflate.ogg', 	'AudioDefault3D',       "tire",			 	 v.data.refNodes[0].ref)

local crash1  = 		sounds.createSFXSource('art/sound/crashsounds/crash1.ogg',  'AudioDefault3D',   "crash1",			 v.data.refNodes[0].ref)
local crash2  = 		sounds.createSFXSource('art/sound/crashsounds/crash2.ogg',  'AudioDefault3D',   "crash2",			 v.data.refNodes[0].ref)
local crash3  = 		sounds.createSFXSource('art/sound/crashsounds/crash3.ogg',  'AudioDefault3D',   "crash3",			 v.data.refNodes[0].ref)
local crash4  = 		sounds.createSFXSource('art/sound/crashsounds/crash4.ogg',  'AudioDefault3D',   "crash4",			 v.data.refNodes[0].ref)
local crash5  = 		sounds.createSFXSource('art/sound/crashsounds/crash5.ogg',  'AudioDefault3D',   "crash5",			 v.data.refNodes[0].ref)
local crash6  = 		sounds.createSFXSource('art/sound/crashsounds/crash6.ogg',  'AudioDefault3D',   "crash6",			 v.data.refNodes[0].ref)
local crash7  = 		sounds.createSFXSource('art/sound/crashsounds/crash7.ogg',  'AudioDefault3D',   "crash7",			 v.data.refNodes[0].ref)
local crash8  = 		sounds.createSFXSource('art/sound/crashsounds/crash8.ogg',  'AudioDefault3D',   "crash8",			 v.data.refNodes[0].ref)
local crash9  = 		sounds.createSFXSource('art/sound/crashsounds/crash9.ogg',  'AudioDefault3D',   "crash9",			 v.data.refNodes[0].ref)
local crash10 = 		sounds.createSFXSource('art/sound/crashsounds/crash10.ogg', 'AudioDefault3D',   "crash10",			 v.data.refNodes[0].ref)
--================================================================VALUES==================================================================







--============================================BLINKER PULSE============================================
local blinking = false
local signalSum = 0

local function playBlink(id)
    if drivingSounds.cameraMode == "dash" then
        if id == 1 then
            sounds.playSoundOnceAtNode("blinker1"..vehicleConfig.Name, v.data.refNodes[0].ref, tonumber(vehicleConfig.BlinkerVolume1))
        elseif id == 2 then
            sounds.playSoundOnceAtNode("blinker2"..vehicleConfig.Name, v.data.refNodes[0].ref, tonumber(vehicleConfig.BlinkerVolume2))
        end
    end
end
local function generateBlinkPulse(dt)
    signalSum = electrics.values.signal_L + electrics.values.signal_R
    if signalSum > 0 then
        if blinking then
            return
        else
            blinking = true
            playBlink(1)
        end
    elseif blinking then
        blinking = false
        playBlink(2)
    end
end
--============================================BLINKER PULSE============================================







--==========================================================CRASH SOUND============================================================
local function crash(breakNode, totalBreakEnergy, isMine)
	if settingsUser.CrashSound == "true" and settingsUser.CrashSound ~= nil then -- If user enabled crash sound
		if crashDelay > 0.1 then
			if isMine == false then sounds.playSoundOnceAtNode("crash"..math.random(10), breakNode, totalBreakEnergy * 0.010)
			else sounds.playSoundOnceAtNode("crash"..math.random(10), breakNode, totalBreakEnergy) end
			crashDelay = 0
		end
	end
end
--==========================================================CRASH SOUND============================================================







--=====================VALUES=======================
local fogMem
local gearMem
local lightsMem
local engineSoundPlayed = false
local brakeSoundSwitch  = false
local rand
local waterTempVolume = 0
local fanPitch = 0
local fanVolume = 0
local frictionDelay = 0
local tirePitch = 0
local tireVolume = 0
--=====================VALUES=======================


local function onUpdate(dt) --ONUPDATE OPEN

	velocity = vec3(obj:getVelocity()):length() -- Get velocity

	if settingsUser.BlinkerSound == "true" and settingsUser.BlinkerSound ~= nil then -- If user enabled blinker sound
		generateBlinkPulse(dt)
	end

	if settingsUser.CustomCrashSound == "true" and settingsUser.CustomCrashSound ~= nil then -- If user enabled custom crash sound
		if velocity < velocityMem - 1 and velocityMem > 3 then -- If velocity descends suddenly it mean crash
			crash(v.data.refNodes[0].ref, (velocityMem-velocity)/2, true) -- So play sound
		end
		velocityMem = velocity
	end
	
	
	if drivingSounds.cameraMode == "dash" then --DASH OPEN
	
	
--============================================SHIFT SOUND============================================== (DASH)
		if settingsUser.ShifterSound == "true" and settingsUser.ShifterSound ~= nil then -- If user enabled shift sounds
			if gearMem ~= electrics.values.gearIndex then
				rand = math.random(3)
				if rand == 1 then sounds.playSoundOnceAtNode("shift1", v.data.refNodes[0].ref, 0.5) end
				if rand == 2 then sounds.playSoundOnceAtNode("shift2", v.data.refNodes[0].ref, 0.5) end
				if rand == 3 then sounds.playSoundOnceAtNode("shift3", v.data.refNodes[0].ref, 0.5) end
			end
			gearMem = electrics.values.gearIndex		
		end
--============================================SHIFT SOUND============================================== (DASH)
	
	
	




--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)		*
		if settingsUser.HandbrakeSound == "true" and settingsUser.HandbrakeSound ~= nil then -- If user enabled handbrake sounds
			if input.parkingbrake == 1 and brakeSoundSwitch == false then --If the handbrake is on 
				sounds.playSoundOnceAtNode("handbrakeLock", v.data.refNodes[0].ref, tonumber(settingsUser.HandbrakeSoundVolume))
				brakeSoundSwitch = true
			elseif input.parkingbrake == 0 and brakeSoundSwitch == true then
				sounds.playSoundOnceAtNode("handbrakeUnlock", v.data.refNodes[0].ref, tonumber(settingsUser.HandbrakeSoundVolume))
				brakeSoundSwitch = false
			end
		end
--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)	



	else
		isSignalOn = false --Prevent signal sound to be played on vehicle reset
		if input.parkingbrake == 1 then brakeSoundSwitch = true end --Prevent handbrake sound to be played on vehicle reset
		if input.parkingbrake == 0 then brakeSoundSwitch = false end
	end --DASH CLOSE


	
--========================================================================TRUCK REVERSE SOUND==========================================================================
	if settingsUser.TruckReverseSound == "true" and settingsUser.TruckReverseSound ~= nil then -- If user enabled reverse sounds
		if vehicleName == "semi" or vehicleConfig.ReverseSound == "true" then --If player drive truck or enabled reverse sound in his vehicle config
			if electrics.values.gearIndex < 0 then --If the gear is "R" or "R2"
				if drivingSounds.cameraMode == "dash" then obj:setVolumePitch(reverseSound, 0.1, 1) else obj:setVolumePitch(reverseSound, 0.3, 1) end --Play sound
			else
				if reverseSound then obj:setVolumePitch(reverseSound, 0, 1) end --Stop sound if gear is no longer "R" or "R2"
			end
		end
	end
--========================================================================TRUCK REVERSE SOUND==========================================================================
	
	
	
	
	
	
	
--==========================================================ENGINE START SOUND============================================================
	if settingsUser.EngineStartingSound == "true" and settingsUser.EngineStartingSound ~= nil then -- If user enabled engine start sound
		if electrics.values.rpm ~= nil and electrics.values.rpm < 1 then --If engine RPM is under 1 (engine stopped)
			engineSoundPlayed = false
		elseif electrics.values.rpm ~= nil and electrics.values.rpm > 0 and engineSoundPlayed == false then --Else if engine is starting
			sounds.playSoundOnceAtNode("start", v.data.refNodes[0].ref, tonumber(settingsUser.EngineStartingSoundVolume)) --Play sound
			engineSoundPlayed = true --Say that the sound have been played to prevent "spam sound"
		end
	end
--==========================================================ENGINE START SOUND============================================================







--=====================================LIGHTS SOUND==========================================	
	if settingsUser.LightsSound == "true" and settingsUser.LightsSound ~= nil then -- If user enabled lights sound
		if electrics.values.lights_state ~= lightsMem or electrics.values.fog ~= fogMem then
			sounds.playSoundOnceAtNode("lights", v.data.refNodes[0].ref, tonumber(settingsUser.LightsSoundVolume))	
		end
		
		lightsMem = electrics.values.lights_state
		fogMem = electrics.values.fog
	end
	
--=====================================LIGHTS SOUND==========================================







--===============ENGINE BEEP SOUND=================	
	if settingsUser.EngineBeepSound == "true" and settingsUser.EngineBeepSound ~= nil then -- If user enabled engine beep sound
		if drivingSounds.cameraMode == "dash" and engineBeepSound == true then
			obj:setVolumePitch(beep, tonumber(settingsUser.EngineBeepSoundVolume), 1)
		else
			obj:setVolumePitch(beep, 0, 1)
		end
	end
--===============ENGINE BEEP SOUND=================	







--================================RADIATOR FAN SOUND=================================	
	if settingsUser.RadiatorFanSound == "true" and settingsUser.RadiatorFanSound ~= nil then -- If user enabled fan sound
		if isRadiatorDamaged == 0 then
			if electrics.values.watertemp > 91 and electrics.values.rpm > 1 then 
				waterTempVolume = electrics.values.watertemp/90 -- Define the volume and the pitch of the fan
				
				if fanVolume < waterTempVolume then -- Fade in sound
					obj:setVolumePitch(rfan, fanVolume/2, fanPitch)
					fanVolume = fanVolume + 0.01 -- Increase fan volume slowly to have fade effect
					fanPitch = fanVolume -- Set fan pitch
					if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
				else -- Regular sound
					fanPitch = waterTempVolume -- Regular sound fan pitch
					if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
					obj:setVolumePitch(rfan, waterTempVolume/2, fanPitch)
				end		
			else -- Fade out sound (when fan is stopping)
				obj:setVolumePitch(rfan, fanVolume/1.5, fanPitch)
				if fanVolume >= 0 then fanVolume = fanVolume - 0.007 end -- If fan volume is not 0 then decrease fan volume slowly
				if fanPitch >= 0 then fanPitch = fanPitch - 0.007 end -- If fan pitch is not 0 then decrease fan volume slowly
			end
		elseif isRadiatorDamaged == 1 then
			obj:setVolumePitch(rfan, 0, 1)
			gui.message({txt="vehicle.drivetrain.deviceBroken", context={deviceName="Radiator fan"}}, 10, "damage.device.")
			isRadiatorDamaged = 2
		end
	end
--================================RADIATOR FAN SOUND=================================	

    if crashDelay < 0.2 then crashDelay = crashDelay + dt end
	
	if frictionDelay < 0.1 then frictionDelay = frictionDelay + dt 
	else obj:setVolumePitch(scrape, 0, 1) end

end --ONUPDATE CLOSE

--====================================FRICTION SOUND====================================	
local frictionVolume = 0
local frictionPitch = 0
local function friction()
	if settingsUser.ScratchSound == "true" and settingsUser.ScratchSound ~= nil then -- If user enabled scratch sound
		
		frictionPitch = velocity/20
		if frictionPitch < 0.8 then frictionPitch = 0.8
		elseif frictionPitch > 1.4 then frictionPitch = 1.4 end
		
		frictionVolume = velocity/20
		if frictionVolume > 1.5 then frictionVolume = 1.5 end
		
		obj:setVolumePitch(scrape, frictionVolume, frictionPitch)
		frictionDelay = 0
	end
end
--====================================FRICTION SOUND====================================







--==========================================================ENGINE SMOKE SOUND============================================================
local function smoke()
	if settingsUser.EngineSmokeSound == "true" and settingsUser.EngineSmokeSound ~= nil then -- If user enabled engine smoke sound
		obj:setVolumePitch(smokeSound, tonumber(settingsUser.EngineSmokeSoundVolume), 1)
		if isRadiatorDamaged == 0 then isRadiatorDamaged = 1 end
	end
end
--==========================================================ENGINE SMOKE SOUND============================================================







--==========================================================TIRE DEFLATE SOUND============================================================
local function tireDeflate(wheel)
	if settingsUser.TireDeflateSound == "true" and settingsUser.TireDeflateSound ~= nil then -- If user enabled reverse sounds
		sounds.playSoundOnceAtNode("tire", wheel, 2) 
		obj:addParticleByNodesRelative(wheel, 1, 1, 6, 0.3, 5)
		--drivingSounds.isTireDeflated = true	
	else
		sounds.playSoundOnceAtNode("TireBurstSound", wheel, 1)
	end
end
--==========================================================TIRE DEFLATE SOUND============================================================







--===============ENGINE BEEP SOUND=================	
local function engineBeep()
	engineBeepSound = true
end
--===============ENGINE BEEP SOUND=================



M.tireDeflate   = tireDeflate
M.crash2        = crash2
M.crash         = crash
M.friction      = friction
M.engineBeep 	= engineBeep
M.jsonInit	    = jsonInit
M.smoke 		= smoke
M.onUpdate	    = onUpdate
M.onReset 		= onInit
M.updateGFX	    = onUpdate

return M