
angular.module('beamng.apps')
.directive('sahMod', ['UiUnits', function (UiUnits) {
  return {  
    template: 
      '<div style="max-height:100%; width:100%; background:transparent;" layout="row" layout-align="center center" layout-wrap>' +
      '<md-button flex style="margin: 2px; min-width: 40px;  max-width: 40px;" md-no-ink class="md-raised" ng-click="previous()">&#171</md-button>' +
      '<md-button flex id="btmid" style="margin: 2px; min-width: 100px;"       md-no-ink class="md-raised" ng-click=""></md-button>' +
      '<md-button flex style="margin: 2px; min-width: 40px;  max-width: 40px;" md-no-ink class="md-raised" ng-click="next()">&#187</md-button>' +
	  '<md-button flex style="margin: 2px; min-width: 40px;  max-width: 40px;" md-no-ink class="md-raised" ng-click="apply()">Ok</md-button>' +  
      '</div>',
	  
    replace: true,
    restrict: 'EA',
    scope: true,
	
    controller: ['$log', '$scope', 'bngApi', function ($log, $scope, bngApi) { 
		$scope.$on('$destroy', function () {
		});

		
	  
		$scope.next = function() {

			bngApi.engineLua(
			
			'     local configsList = readJsonFile("mods/sirenmod/cache/configsList.json")     ' +
			'     if configsList[sahmod.iApp + 1] ~= nil then sahmod.iApp = sahmod.iApp + 1 end     ' +
			'     if configsList[sahmod.iApp] ~= nil then be:executeJS(\'document.getElementById("btmid").textContent= "  \'..   configsList[sahmod.iApp]:gsub("mods/sirenmod/vehiclesConfig/","")    .. \'"   \') end    '
			
			)

		};
		
		
		$scope.previous = function() {

			bngApi.engineLua(
			
			'     local configsList = readJsonFile("mods/sirenmod/cache/configsList.json")     ' +
			'     if configsList[sahmod.iApp - 1] ~= nil then sahmod.iApp = sahmod.iApp - 1 end     ' +
			'     if configsList[sahmod.iApp] ~= nil then be:executeJS(\'document.getElementById("btmid").textContent= "  \'..   configsList[sahmod.iApp]:gsub("mods/sirenmod/vehiclesConfig/","")    .. \'"   \') end    '
			
			)
		
		};
		
		
		$scope.apply = function() {
			
			bngApi.engineLua(
			
			'     if sahmod.iApp ~= 0 then local i = sahmod.iApp     local configsList = readJsonFile("mods/sirenmod/cache/configsList.json")    ' +
			'     local vehicle = configsList[i]:gsub("mods/sirenmod/vehiclesConfig/","")    ' +
			'     be:getPlayerVehicle(0):queueLuaCommand(\' jsonInit.appApply("\'..vehicle..\'") \') end   '
			
			)		
			
		}; 
		
		
		
    }]
  };
}]);